/*
 * MBIC_Bootloader.h
 *
 *  Created on: 2020. 5. 18.
 *      Author: parkyj
 */

#ifndef MBIC_BOOTLOADER_H_
#define MBIC_BOOTLOADER_H_



#define MBIC_HEADER_SIZE 22
#define MBIC_TAIL_SIZE 3

#define MBIC_PREAMBLE0 0x16
#define MBIC_PREAMBLE1 0x16
#define MBIC_PREAMBLE2 0x16
#define MBIC_PREAMBLE3 0x16
#define MBIC_SUBUID0 0x00
#define MBIC_SUBUID1 0xF1
#define MBIC_RCODE
#define MBIC_TRID
#define MBIC_SEQNUM
#define MBIC_TTL
#define MBIC_TIME
#define MBIC_ERRRESPONSE 0x00
#define MBIC_CMD
#define MBIC_LENGTH
#define MBIC_CHECKSHUM_INDEX MBIC_HEADER_SIZE - 1 //CheckSUM REMOVE INDEX
#define MBIC_ETX 0x03
#define MBIC_NODE_MU 0x80
#define MARK_START_POSITION						0
#define TYPE_START_POSITION						9	
#define FILE_TYPE_START_POSITION				10
#define VERSION_START_POSITION					11
#define FILENAME_START_POSITION					14
#define CREATION_TIME_START_POSITION			55
#define LENGTH_START_POSITION					61
#define CRC_START_POSITION						65
#define RESERVED_START_POSITION					69





typedef struct{
    uint16_t Length;
    uint16_t Crcchk;
    bool FileChk;
}BootLoaderDataCheck_st;




#endif /* MBIC_BOOTLOADER_H_ */
